clear all
close all

%% Generate test data%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cfg.mode=2;
cfg.verbose=0;
L=1:0.05:300;

for subject=1:10
    for trials=1:10
        [x,y,z] = lorenzgen( L );
        data{subject}{trials}(1,:)=x';
        [results]=surrogates(data{subject}{trials}(1,:),cfg);
        data_surr{subject}{trials}(1,:)=results.surr';
        data{subject}{trials}(2,:)=y';
        [results]=surrogates(data{subject}{trials}(2,:),cfg);
        data_surr{subject}{trials}(2,:)=results.surr';
        data{subject}{trials}(3,:)=z';
        [results]=surrogates(data{subject}{trials}(3,:),cfg);
        data_surr{subject}{trials}(3,:)=results.surr';
    end

% save(['data_orig_' num2str(subject) '.mat'],'data');
% save(['data_surr_' num2str(subject) '.mat'],'data_surr');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Anaylze data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cfg_a1.Data=data;
cfg_a1.methodnames={'entropybin','hurst'};
cfg_a1.dim=3;
cfg_a1.tau=9;
cfg_a1.verbose=0;
% [handles]=prepare_wrapper(handles);
% [handles]=optimize_wrapper(handles);
[cfg_a1]=generate_cfg(cfg_a1);
[cfg_a1]=batch_wrapper(cfg_a1);

cfg_a2.Data=data_surr;
cfg_a2.methodnames={'entropybin','hurst'};
cfg_a2.dim=3;
cfg_a2.tau=9;
cfg_a2.verbose=0;
% [handles]=prepare_wrapper(handles);
% [handles2]=optimize_wrapper(handles2);
[cfg_a2]=generate_cfg(cfg_a2);
[cfg_a2]=batch_wrapper(cfg_a2);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Run statistics %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Monte-Carlo

cfg=[];
cfg.method='entropybin'; %'hurst'
cfg.outputvar='Hx';%'expo';
cfg.numperm=1000;
cfg.vars=1:3;
cfg.plt=1;

[data1,data2] = fetch_data(cfg,cfg_a1,cfg_a2);

results_monte=nolitia_monte(data1,data2,cfg);

%% Cluster-based permutation analysis
cfg=[];
cfg.method='entropybin'; %'hurst'
cfg.outputvar='SI';%'expo';
cfg.numperm=1000;
cfg.vars=1:3;
cfg.maxcluster='sumt';
cfg.clustalpha=0.05;
cfg.plt=1;

results_cbpa=nolitia_cbpa(data1,data2,cfg);

